<CsoundSynthesizer>
<CsOptions>
-m 128
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1
seed 0 

/*
solution of exercise in Pesaro_4.csd
*/

opcode start, 0, S
 ;note that this is k-rate!
 S_instr xin
 event "i", S_instr, 0, 1
endop





instr A

 //set initial status
 kState init 1 ;1=play, 0=pause, -1=do nothing

 //set kState whenever A_play_done or A_pause_done send a signal
 k_A_play_done chnget "A_play_done"
 k_A_pd_changed changed k_A_play_done
 k_A_pause_done chnget "A_pause_done"
 k_A_pd_changed changed k_A_pause_done
 if k_A_play_done == 1 && k_A_pd_changed == 1 then
  kState = 0
 elseif k_A_pause_done ==1 && k_A_pd_changed == 1 then
  kState = 1
 endif
  
 //start play/pause depending on kState
 if kState == 1 then
  start "A_play"
 elseif kState == 0  then
  start "A_pause"
 endif
 
 //reset state
 kState = -1
 
endin
schedule("A",0,-1)

instr A_play

 iMidiNote random 70, 80
 iDb random -30, -20
 p3 random 3, 5
 
 aSound poscil ampdb(iDb), mtof(iMidiNote)
 aOut linen aSound, p3/2, p3, p3/2
 
 out aOut, aOut  
 
 if release() == 1 then
  chnset k(1), "A_play_done"
 else
  chnset k(0), "A_play_done"
 endif

endin

instr A_pause

 p3 random 5, 8
 //start play if last k-cycle is reached
 if release() == 1 then
  chnset k(1), "A_pause_done"
 else
  chnset k(0), "A_pause_done"
 endif

endin




instr B

 //set initial status
 kState init 1 ;1=play, 0=pause, -1=do nothing

 //set kState whenever B_play_done or B_pause_done send a signal
 k_B_play_done chnget "B_play_done"
 k_B_pd_changed changed k_B_play_done
 k_B_pause_done chnget "B_play_done"
 k_B_pd_changed changed k_B_pause_done
 if k_B_play_done == 1 && k_B_pd_changed == 1 then
  kState = 0
 elseif k_B_pause_done ==1 && k_B_pd_changed == 1 then
  kState = 1
 endif
  
 //start play/pause depending on kState
  if kState == 1 then
   start "B_play"
  elseif kState == 0  then
   start "B_pause"
  endif
 
 //reset state
 kState = -1
 
endin
schedule "B", 0, -1

instr B_play

 p3 random 1, 2
 iMediumFreq random 3, 6
 
 kTrig metro iMediumFreq
 if kTrig == 1 then
  kImpulsePitch random 60, 70
  kDb random -12, 0
  kOffset random 0, 1/iMediumFreq
  event "i", "ImpFiltered", kOffset, 1, kImpulsePitch, kDb
 endif

 if release() == 1 then
  chnset k(1), "B_play_done"
 else
  chnset k(0), "B_play_done"
 endif

endin

instr B_pause

 p3 random 5, 10
 if release() == 1 then
  chnset k(1), "B_pause_done"
 else
  chnset k(0), "B_pause_done"
 endif

endin


instr ImpFiltered

 iMidiNote = p4
 iDb = p5
 iQ random 1/3, 2
 
 aImp mpulse ampdb(iDb), p3
 aFilt mode aImp, mtof(iMidiNote), iQ
 
 out aFilt, aFilt

endin

</CsInstruments>
<CsScore>

</CsScore>
</CsoundSynthesizer>
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>100</x>
 <y>100</y>
 <width>320</width>
 <height>240</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>255</r>
  <g>255</g>
  <b>255</b>
 </bgcolor>
</bsbPanel>
<bsbPresets>
</bsbPresets>
